Package: dictionar6
Title: R6 Dictionary Interface
Description: Efficient object-oriented R6 dictionary capable of holding objects of any class, including R6. Typed and untyped dictionaries are provided as well as the 'usual' dictionary methods that are available in other OOP languages, for example listing keys, items, values, and methods to get/set these.
Version: 0.1.3
Authors@R:
  person(given = "Raphael",
             family = "Sonabend",
             role = c("aut","cre"),
             email = "raphaelsonabend@gmail.com",
             comment = c(ORCID = "0000-0001-9225-4654"))
License: MIT + file LICENSE
URL: https://xoopR.github.io/dictionar6/, https://github.com/xoopR/dictionar6/
BugReports: https://github.com/xoopR/dictionar6/issues
Config/testthat/edition: 3
Encoding: UTF-8
NeedsCompilation: no
Roxygen: list(markdown = TRUE, r6 = TRUE)
RoxygenNote: 7.1.1
Imports:
  ooplah,
  R6
Suggests:
  testthat

dictionar6
================

<img src="man/figures/logo.png" align="right" alt="" width="120" />

[![CRAN Status
Badge](https://www.r-pkg.org/badges/version-ago/dictionar6)](https://cran.r-project.org/package=dictionar6)
[![CRAN
Checks](https://cranchecks.info/badges/worst/dictionar6)](https://cran.r-project.org/web/checks/check_results_dictionar6.html)
[![R-CMD-check /
codecov](https://github.com/xoopR/dictionar6/actions/workflows/check-covr.yml/badge.svg?branch=main)](https://github.com/xoopR/dictionar6/actions/workflows/check-covr.yml)

[![Repo
Status](https://www.repostatus.org/badges/latest/active.svg)](https://github.com/xoopR/dictionar6)
[![Lifecycle](https://lifecycle.r-lib.org/articles/figures/lifecycle-experimental.svg)](https://github.com/xoopR/dictionar6)

[![CRAN
Downloads](https://cranlogs.r-pkg.org/badges/grand-total/dictionar6)](https://cran.r-project.org/package=dictionar6)
[![codecov](https://codecov.io/gh/xoopR/dictionar6/branch/master/graph/badge.svg)](https://codecov.io/gh/xoopR/dictionar6)
[![dependencies](https://tinyverse.netlify.com/badge/dictionar6)](https://CRAN.R-project.org/package=dictionar6)
[![License:
MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)

## What is dictionar6?

**dictionar6** is an R6 dictionary interface that makes use of symbolic
representation to efficiently store R6 and non-R6 objects as symbols to
prevent issues with cloning, large object sizes, or construction
bottlenecks. The dictionary contains all ‘usual’ methods for getting and
setting elements.

## Main Features

Some main features/key use-cases of **dictionar6** includes:

-   Construction of untyped dictionaries

``` r
dct(a = 1, b = "2")
```

    ## {a: 1, b: 2}

-   Construction of typed dictionaries

``` r
dct(a = 1L, b = 2L, c = 3L, types = "integer")
```

    ## {a: 1, b: 2, c: 3}

-   Getting values

``` r
d <- dct(a = 1, b = 2)
d$has("a")
```

    ## [1] TRUE

``` r
d$get("a")
```

    ## [1] 1

``` r
d[c("a", "b")]
```

    ## $a
    ## [1] 1
    ## 
    ## $b
    ## [1] 2

-   Setting values

``` r
d <- dct(a = 1, b = 2)
d$rekey("a", "c")
d$keys
```

    ## [1] "c" "b"

``` r
d$revalue("b", 3)
d$items
```

    ## $c
    ## [1] 1
    ## 
    ## $b
    ## [1] 3

-   Safe cloning of R6 objects

``` r
r <- RClass$new(1)
r$values()
```

    ## [1] 1

``` r
d <- dct(a = r)
# default is to clone
d$get("a", clone = TRUE)$add(2)
# r is unaffected
r$values()
```

    ## [1] 1

``` r
# if we don't clone...
d$get("a", clone = FALSE)$add(2)
# r is affected
r$values()
```

    ## [1] 1 2

## Installation

For the latest release on
[CRAN](https://CRAN.R-project.org/package=dictionar6), install with

``` r
install.packages("dictionar6")
```

Otherwise for the latest stable build

``` r
remotes::install_github("xoopR/dictionar6")
```

## Use-cases

**dictionar6** is currently used in
**[param6](https://CRAN.R-project.org/package=param6)** to provide a
symbolic representation for R6 classes. This is incredibly useful to
prevent storing unnecessarily large R6 objects.
**[param6](https://CRAN.R-project.org/package=param6)** comes pre-loaded
with a
[Dictionary](https://xoopr.github.io/dictionar6/reference/Dictionary.html)
of mathematical sets where the keys are symbolic representations of the
sets and the values are the sets themselves, this allows users to refer
to R6 objects with their character representation without having to
continually construct new objects.

## Future Plans

The **dictionar6** API is still experimental and may be subject to major
changes. Currently it’s primary use-case is in
**[param6](https://CRAN.R-project.org/package=param6)**, minor or major
changes will be made to satisfy this dependency. Future development will
then focus on code quality and speed.

## Package Development and Contributing

**dictionar6** is released under the [MIT
licence](https://opensource.org/licenses/MIT). We welcome and appreciate
all [new issues](https://github.com/xoopR/dictionar6/issues) relating to
bug reports, questions and suggestions. You can also [start a
discussion](https://github.com/xoopR/dictionar6/discussions) for more
extensive feedback or feature suggestion.

---
title: "dictionar6"
output: github_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
library(dictionar6)
ref <- function(val) sprintf("[%s](https://xoopr.github.io/dictionar6/reference/%s.html)",
                             as.character(substitute(val)),
                             as.character(substitute(val)))
cran <- function(val) sprintf("**[%s](https://CRAN.R-project.org/package=%s)**",
                              as.character(substitute(val)),
                              as.character(substitute(val)))
gh <- function(org, repo) sprintf("**[%s](https://github.com/%s/%s)**", repo, org, repo)
pkg <- function(pkg) sprintf("**%s**", as.character(substitute(pkg)))
d6 <- "**dictionar6**"
```

<img src="man/figures/logo.png" align="right" alt="" width="120" />

[![CRAN Status Badge](https://www.r-pkg.org/badges/version-ago/dictionar6)](https://cran.r-project.org/package=dictionar6)
[![CRAN Checks](https://cranchecks.info/badges/worst/dictionar6)](https://cran.r-project.org/web/checks/check_results_dictionar6.html)
[![R-CMD-check / codecov](https://github.com/xoopR/dictionar6/actions/workflows/check-covr.yml/badge.svg?branch=main)](https://github.com/xoopR/dictionar6/actions/workflows/check-covr.yml)

[![Repo Status](https://www.repostatus.org/badges/latest/active.svg)](https://github.com/xoopR/dictionar6)
[![Lifecycle](https://lifecycle.r-lib.org/articles/figures/lifecycle-experimental.svg)](https://github.com/xoopR/dictionar6)

[![CRAN Downloads](https://cranlogs.r-pkg.org/badges/grand-total/dictionar6)](https://cran.r-project.org/package=dictionar6)
[![codecov](https://codecov.io/gh/xoopR/dictionar6/branch/master/graph/badge.svg)](https://codecov.io/gh/xoopR/dictionar6)
[![dependencies](https://tinyverse.netlify.com/badge/dictionar6)](https://CRAN.R-project.org/package=dictionar6)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)

## What is dictionar6?

`r d6` is an R6 dictionary interface that makes use of symbolic representation to efficiently store R6 and non-R6 objects as symbols to prevent issues with cloning, large object sizes, or construction bottlenecks. The dictionary contains all 'usual' methods for getting and setting elements.

## Main Features

Some main features/key use-cases of `r d6` includes:

* Construction of untyped dictionaries

```{r construction untyped}
dct(a = 1, b = "2")
```

* Construction of typed dictionaries

```{r construction typed}
dct(a = 1L, b = 2L, c = 3L, types = "integer")
```

* Getting values

```{r get}
d <- dct(a = 1, b = 2)
d$has("a")
d$get("a")
d[c("a", "b")]
```

* Setting values

```{r set}
d <- dct(a = 1, b = 2)
d$rekey("a", "c")
d$keys
d$revalue("b", 3)
d$items
```

* Safe cloning of R6 objects

```{r R6, echo=FALSE}
RClass <- R6::R6Class("RClass",
  public = list(
    initialize = function(x) private$.x <- x,
    add = function(x) {
      private$.x <- c(private$.x, x)
      invisible(self)
    },
    values = function(x) unlist(private$.x)
  ),
  private = list(.x = list())
)
```

```{r store R6}
r <- RClass$new(1)
r$values()
d <- dct(a = r)
# default is to clone
d$get("a", clone = TRUE)$add(2)
# r is unaffected
r$values()

# if we don't clone...
d$get("a", clone = FALSE)$add(2)
# r is affected
r$values()
```

## Installation

For the latest release on [CRAN](https://CRAN.R-project.org/package=dictionar6), install with
```{r eval=FALSE}
install.packages("dictionar6")
```

Otherwise for the latest stable build
```{r eval=FALSE}
remotes::install_github("xoopR/dictionar6")
```

## Use-cases

`r d6` is currently used in `r cran(param6)` to provide a symbolic representation for R6 classes. This is incredibly useful to prevent storing unnecessarily large R6 objects. `r cran(param6)` comes pre-loaded with a `r ref("Dictionary")` of mathematical sets where the keys are symbolic representations of the sets and the values are the sets themselves, this allows users to refer to R6 objects with their character representation without having to continually construct new objects.

## Future Plans

The `r d6` API is still experimental and may be subject to major changes. Currently it's primary use-case is in `r cran(param6)`, minor or major changes will be made to satisfy this dependency. Future development will then focus on code quality and speed.

## Package Development and Contributing

`r d6` is released under the [MIT licence](https://opensource.org/licenses/MIT). We welcome and appreciate all [new issues](https://github.com/xoopR/dictionar6/issues) relating to bug reports, questions and suggestions. You can also [start a discussion](https://github.com/xoopR/dictionar6/discussions) for more extensive feedback or feature suggestion.

#' Construct a Dictionary
#' @description Sugar function wrapping `[Dictionary]$new`.
#' @param ... (`ANY`) \cr
#' Named arguments with names corresponding to the items to add to the
#' dictionary, where the keys are the names and the values are the
#' elements. Names must be unique.
#' @param x (`list()`) \cr
#' A named list with the names corresponding to the items to add to the
#' dictionary, where the keys are the list names and the values are the
#' list elements. Names must be unique.
#' @param types (`character()`) \cr
#' If non-NULL then `types` creates a typed dictionary in which all
#' elements of the dictionary must inherit from these `types`. Any class
#' can be given to `types` as long as there is a valid `as.character`
#' method associated with the class.
#' @examples
#' # untyped
#' dct(a = 1, b = 2, c = "a")
#'
#' # typed - class is forced
#' dct(a = 1L, b = 2L, c = 3L, types = "integer")
#'
#' # list constructor
#' dct(x = list(a = 1, b = 2, c = "a"))
#'
#' # with R6
#' d <- dct(a = 1)
#' dct(d = d)
#' @export
dct <- function(..., x = list(...), types = NULL) {
    Dictionary$new(x = x, types = types)
}

.Dictionary__initialize <- function(self, private, x, types) { # nolint
  if (length(x)) {
    private$.items <- list2env(
       assert_named_list(x, types = types),
       parent = emptyenv(),
       hash = TRUE
    )
  }

  private$.types <- types
  invisible(self)
}

.Dictionary__add <- function(self, private, x, keys, values) { # nolint
   if (!length(x)) {
      if (is.null(keys) || is.null(values)) {
         stop("Either a named list or 'keys' and 'values' must be provided.") # nolint
      }
      if (!is.R6Object(values) && length(values) > 1) {
         values <- as.list(values)
      } else if (!is.list(values)) {
         values <- list(values)
      }
      x <- setNames(as.list(values), keys)
   }

   # signif quicker than first concatenating and then checking type
   if (any(self$has(ls(x)))) {
      stop("Some or all keys of new values already exist in the dictionary")
   }

   assert_named_list(x, types = private$.types)

   if (is.list(x)) {
      private$.items <- list2env(x, parent = private$.items, hash = TRUE)
   } else {
      parent.env(x) <- private$.items
      private$.items <- x
   }

   invisible(self)
}

.Dictionary__remove <- function(self, private, x) { # nolint
   lapply(x, rm_env, private$.items)
   invisible(self)
}

.Dictionary__assert_contains <- function(self, private, keys) { # nolint
   if (all(self$has(keys))) {
      invisible(keys)
   } else {
      stop("Not all keys in self$keys")
   }
}

.Dictionary__get <- function(self, private, x, clone = TRUE) { # nolint
   if (!(length(private$.types) == 1 || length(x) == 1)) {
      stop("'get' can only be used if length of 'x' is '1' or if Dictionary has one type.") # nolint
   }

   x <- unlist(lapply(
      mget(x, private$.items, inherits = TRUE),
      function(.x) {
         if (is.R6Object(.x) && clone) {
            .x$clone(deep = TRUE)
         } else {
            .x
         }
      }
   ))

   ## catch not unlisting R6
   if (length(x) == 1) {
      x <- x[[1]]
   }

   if (!is.list(x)) {
      x <- unname(x)
   }

   x
}

.Dictionary__get_list <- function(self, private, x, clone = TRUE) { # nolint
   lapply(
      mget(x, private$.items, inherits = TRUE),
      function(.x) {
         if (is.R6Object(.x) && clone) {
            .x$clone(deep = TRUE)
         } else {
            .x
         }
      })
}

.Dictionary__has <- function(self, private, x) { # nolint
   !is.na(mget(x, private$.items, ifnotfound = NA, inherits = TRUE))
}

.Dictionary__has_value <- function(self, private, x) { # nolint
   x %in% self$values
}

.Dictionary__print <- function(self, private, n) { # nolint
   cat(as.character(self, n = n), "\n")
}

.Dictionary__summary <- function(self, private, n) { # nolint
   if (self$typed) {
      cat(sprintf("Typed dictionary of %d items and types: %s.\n",
                  self$length, string_as_set(self$types)))
   } else {
      cat(sprintf("Untyped dictionary of %d items.\n", self$length))
   }
   cat(as.character(self, n = n), "\n")
}

.Dictionary__rekey <- function(self, private, key, new_key) { # nolint
   stopifnot(length(key) == 1)
   self$assert_contains(key)

   if (self$has(new_key)) {
     stop("'new_key' already exists in self$keys")
   }

   rename_env_item(key, new_key, private$.items)
   invisible(self)
}

.Dictionary__revalue <- function(self, private, key, new_value) { # nolint
   stopifnot(length(key) == 1)
   self$assert_contains(key)
   if (self$typed) {
      stopifnot(inherits(key, self$types))
   }

   update_env_value(key, new_value, private$.items)
   invisible(self)
}

.Dictionary__merge <- function(self, private, x) { # nolint

   if (inherits(x, "Dictionary")) {
      self$add(private(x)$.items)
   } else if (is.list(x)) {
      lapply(x, function(.x) self$add(private(.x)$.items))
   } else {
      stop("'x' should either be a Dictionary or list of Dictionaries.")
   }
   invisible(self)
}

.Dictionary__values <- function(self, private) { # nolint
   if (length(private$.types == 1)) {
      unname(unlist(self$items))
   } else {
      unname(self$items)
   }
}

.Dictionary__items <- function(self, private, x) { # nolint
   if (missing(x)) {
      as_list_env(private$.items)
   } else {
      if (length(x)) {
         private$.items <- list2env(
            assert_named_list(x, private$.types),
            parent = emptyenv(),
            hash = TRUE
         )
      } else {
         private$.items <- emptyenv()
      }
     invisible(self)
   }
}

#' @export
`[.Dictionary` <- function(x, i) {
  x$get_list(i)
}

#' @export
`[<-.Dictionary` <- function(x, i, value) { # nolint
  x$add(keys = i, values = value)
  invisible(x)
}

#' @export
length.Dictionary <- function(x) {
  x$length
}

#' @export
summary.Dictionary <- function(object, n = 2, ...) {
  object$summary(n = n)
}

#' @export
as.character.Dictionary <- function(x, n = 2, ...) { # nolint
  keys <- x$keys
  values <- vapply(x$values, as.character, character(1), USE.NAMES = FALSE)

  lng <- x$length
  if (lng > (2 * n)) {
    string <- paste0(
      paste(keys[1:n], values[1:n],
        sep = ": ",
        collapse = ", "
      ),
      ", ..., ", paste(keys[(lng - n + 1):lng],
        values[(lng - n + 1):lng],
        sep = ": ", collapse = ", "
      )
    )
  } else {
    string <- paste(keys, values, sep = ": ", collapse = ", ")
  }

  sprintf("{%s}", string)
}

#' @export
c.Dictionary <- function(...) {
  x <- list(...)
  types <- vapply(x, function(.x) list(.x$typed, length(.x$types), .x$types),
                  vector("list", 3))
  # different typing
  if (length(unique(types[1, ])) > 1) {
    stop("Can only combine Dictionaries if all typed or all untyped.")
    # all typed or untyped
  } else {
    # untyped
    if (!unlist(types[1, 1])) {
      Dictionary$new(x = unlist(lapply(x, "[[", "items"), FALSE))
      # typed
    } else {
      # different type lengths
      if (length(unique(types[2, ])) > 1) {
        stop("Can only combine typed Dictionaries of the same type(s).")
      } else {
        if (length(unique(unlist(types[3, ]))) != types[2, 1][[1]]) {
          stop("Can only combine typed Dictionaries of the same type(s).")
        } else {
          Dictionary$new(x = unlist(lapply(x, "[[", "items"), FALSE),
                         types = unlist(types[3, 1]))
        }
      }
    }
  }
}

ls_env <- function(env) {
  names(as_list_env(env))
}

length_env <- function(env) {
  length(as_list_env(env))
}

as_list_env <- function(env) {
  c(
    as.list(env),
    tryCatch(as_list_env(parent.env(env)), error = function(e) NULL)
  )
}

where_env <- function(nm, env) {
  if (!exists(nm, env)) {
    stop(sprintf("'%s' does not exist in 'env' or its parents", nm))
  }

  if (exists(nm, env, inherits = FALSE)) {
    env
  } else {
    where_env(nm, parent.env(env))
  }
}


rm_env <- function(nm, env) {
  rm(list = nm, envir = where_env(nm, env))
  invisible(env)
}

update_env_value <- function(nm, value, env) {
  env <- where_env(nm, env)
  env[[nm]] <- value
  invisible(env)
}

rename_env_item <- function(nm, new_nm, env) {
  if (exists(new_nm, env)) {
    stop(sprintf("'%s' already exists in 'env'", new_nm))
  }

  which_env <- where_env(nm, env)

  which_env[[new_nm]] <- which_env[[nm]]
  rm(list = nm, envir = which_env)

  invisible(env)
}

test_that("assert_named_list", {
    expect_error(assert_named_list(1), "must be a list")
    expect_error(assert_named_list(list(1)), "'x' must have unique")
    expect_error(assert_named_list(list(a = 1, a = 2)), "'x' must have unique")
})

test_that("where_env", {
    e1 <- list2env(list(a = 1))
    e2 <- list2env(list(b = 2), parent = e1)
    expect_equal(where_env("a", e2), e1)
})

test_that("update_env_value", {
    e1 <- list2env(list(a = 1))
    e2 <- list2env(list(b = 2), parent = e1)
    update_env_value("a", 3, e2)
    expect_equal(e1$a, 3)

    expect_error(update_env_value("e", 3, e2), "'e' does not exist")
})

test_that("rename_env_item", {
    e1 <- list2env(list(a = 1))
    e2 <- list2env(list(b = 2), parent = e1)

    expect_error(rename_env_item("a", "b", e2), "already exists")
    expect_error(rename_env_item("e", "d", e2), "'e' does not exist")

    rename_env_item("a", "f", e2)
    expect_equal(e1$a, NULL)
    expect_equal(e1$f, 1)
})

string_as_set <- function(str) {
    if (!is.null(str)) {
        sprintf("{%s}", paste0(str, collapse = ", "))
    }
}


assert_named_list <- function(x, types = NULL) {

    if (!inherits(x, c("list", "environment"))) {
      stop("'x' must be a list or environment")
    }

    if (is.list(x) && (is.null(nms <- names(x)) || anyDuplicated(nms))) {
      stop("'x' must have unique names")
    }

    if (!is.null(types)) {
      if (!all(vapply(x, inherits, logical(1), what = types))) {
        stop(sprintf(
          "All elements of 'x' should inherit from %s",
          string_as_set(types)
        ))
      }
    }

  invisible(x)
}

#' @title R6 Dictionary
#' @description Dictionaries are essential objects in other object-oriented
#' languages, such as Python. The primary function of a dictionary is to store
#' items in a key-value pair. Where the key is the name of the item and the
#' value is the value. This object contains all the 'usual' methods that would
#' be found in other languages, including setting and getting values,
#' adding and removing items, and containedness checks.
#' @export
Dictionary <- R6Class("Dictionary",
  private = list(
    .items = new.env(parent = emptyenv()),
    .types = NULL,
    deep_clone = function(name, value) {
      switch(
        name,
        ".items" = list2env(lapply(value, function(.x) {
            if (is.R6Object(.x)) {
              .x$clone(deep = TRUE)
            } else {
              .x
            }
          }), parent = emptyenv(), hash = TRUE),
        value
      )
    }
  ),

  public = list(
    #' @description Constructs a `Dictionary` object.
    #' @param ... (`ANY`) \cr
    #' Named arguments with names corresponding to the items to add to the
    #' dictionary, where the keys are the names and the values are the
    #' elements. Names must be unique.
    #' @param x (`list()`) \cr
    #' A named list with the names corresponding to the items to add to the
    #' dictionary, where the keys are the list names and the values are the
    #' list elements. Names must be unique.
    #' @param types (`character()`) \cr
    #' If non-NULL then `types` creates a typed dictionary in which all
    #' elements of the dictionary must inherit from these `types`. Any class
    #' can be given to `types` as long as there is a valid `as.character`
    #' method associated with the class.
    initialize = function(..., x = list(...), types = NULL) {
      .Dictionary__initialize(self, private, x, types)
    },

    #' @description Add new items to the dictionary.
    #' @param x (`list()`) \cr
    #' Same as initialize, items to add to the list.
    #' @param keys (`character()`) \cr
    #' If `x` is NULL then `keys` and `values` can be provided to add the
    #' new items by a character vector of keys and list of values instead.
    #' @param values (`list()`) \cr
    #' If `x` is NULL then `keys` and `values` can be provided to add the
    #' new items by a list of keys and values instead.
    add = function(x = list(), keys = NULL, values = NULL) {
      .Dictionary__add(self, private, x, keys, values)
    },

    #' @description Change the name of a given key.
    #' @param key (`character(1)`) \cr
    #' Key to rename.
    #' @param new_key (`character(1)`) \cr
    #' New name of key, must not already exist in dictionary.
    rekey = function(key, new_key) {
      .Dictionary__rekey(self, private, key, new_key)
    },

    #' @description Change the value of a given item.
    #' @param key (`character(1)`) \cr
    #' Key of item to revalue.
    #' @param new_value (`character(1)`) \cr
    #' New value of item.
    revalue = function(key, new_value) {
      .Dictionary__revalue(self, private, key, new_value)
    },

    #' @description Removes the given item from the list.
    #' @param key (`character(1)`) \cr
    #' Key of item to remove.
    remove = function(key) {
      .Dictionary__remove(self, private, key)
    },

    #' @description Gets the given items from the dictionary. If only one
    #' item is requested then returns the (unlisted) item, or if multiple items
    #' are requested as the dictionary is typed, then the unlisted items are
    #' returned.
    #' @param keys (`character()`) \cr
    #' Keys of items to get.
    #' @param clone (`logical(1)`) \cr
    #' If `TRUE` (default) then deep clones R6 objects if requested.
    get = function(keys, clone = TRUE) {
      .Dictionary__get(self, private, keys, clone)
    },

    #' @description Gets the given items from the dictionary as list.
    #' @param keys (`character()`) \cr
    #' Keys of items to get.
    #' @param clone (`logical(1)`) \cr
    #' If `TRUE` (default) then deep clones R6 objects if requested.
    get_list = function(keys, clone = TRUE) {
      .Dictionary__get_list(self, private, keys, clone)
    },

    #' @description Checks if the given key is in the list, returns a logical.
    #' @param key (`character(1)`) \cr
    #' Key to check.
    has = function(key) .Dictionary__has(self, private, key),

    #' @description Asserts if the given keys are in the list, returns keys
    #' invisibly if assertion passes otherwise errors.
    #' @param keys (`character()`) \cr
    #' Keys to check.
    assert_contains = function(keys) {
      .Dictionary__assert_contains(self, private, keys)
    },

    #' @description Checks if the given value is in the list, returns a
    #' logical.
    #' @param value (`ANY`) \cr
    #' Value to check.
    has_value = function(value) .Dictionary__has_value(self, private, value),

    #' @description Prints dictionary.
    #' @param n (`integer(1)`) \cr
    #' Number of items to print on either side of ellipsis.
    print = function(n = 2) .Dictionary__print(self, private, n),

    #' @description Summarises dictionary.
    #' @param n (`integer(1)`) \cr
    #' Number of items to print on either side of ellipsis.
    summary = function(n = 2) .Dictionary__summary(self, private, n),

    #' @description Merges another dictionary, or list of dictionaries, into
    #' self.
    #' @param x (`Dictionary(1) | list()`) \cr
    #' Dictionary or list of dictionaries to merge in, must have unique keys.
    merge = function(x) .Dictionary__merge(self, private, x)
  ),

  active = list(
    #' @field keys None -> `character()` \cr
    #' Get dictionary keys.
    keys = function() ls_env(private$.items),

    #' @field values None -> `list()` \cr
    #' Get dictionary values.
    values = function() .Dictionary__values(self, private),

    #' @field items `list() -> self` / None -> `list()` \cr
    #' If `x` is missing then returns the dictionary items. \cr
    #' If `x` is not missing then used to set items in the dictionary.
    items = function(x) .Dictionary__items(self, private, x),

    #' @field length None -> `integer(1)` \cr
    #' Get dictionary length as number of items.
    length = function() length_env(private$.items),

    #' @field typed None -> `logical(1)` \cr
    #' Get if the dictionary is typed (`TRUE`) or not (`FALSE`).
    typed = function() !is.null(private$.types),

    #' @field types None -> `character()` \cr
    #' Get the dictionary types (NULL if un-typed).
    types = function() private$.types
  )
)

library(testthat)

  Set <- R6Class("Set",
    public = list(
      initialize = function(x) private$.x <- x,
      add = function(x) {
        private$.x <- c(private$.x, x)
        invisible(self)
      },
      values = function(x) {
        unlist(private$.x)
      }
    ),
    private = list(.x = list())
  )
test_that("untyped construction", {
  # empty
  expect_silent(Dictionary$new())
  # elements same types
  expect_silent(Dictionary$new(x = list(a = 1, b = 1)))
  # elements different types
  expect_silent(Dictionary$new(x = list(a = 1, b = 2L, c = "c")))
  # not unique
  expect_error(Dictionary$new(x = list(a = 1, a = 2)), "unique")
})

test_that("typed construction", {
  # empty
  expect_silent(Dictionary$new(types = "numeric"))
  # elements same types
  expect_silent(Dictionary$new(x = list(a = 1, b = 1), types = "numeric"))
  expect_error(Dictionary$new(x = list(a = 1, b = 1), types = "integer"), "integer")
  # elements different types
  expect_error(Dictionary$new(x = list(a = 1, b = "b"), types = "numeric"),
               "All elements")
  expect_silent(Dictionary$new(x = list(a = 1, b = "b"), types = c("numeric",
                                                               "character")))
  # custom types
  expect_silent(Dictionary$new(x = list(r = Set$new(1), b = Set$new(2)),
                               types = "Set"))
})

test_that("add untyped", {
  d_untyped <- Dictionary$new(x = list(a = 1, b = 2))

  expect_silent(d_untyped$add(list(c = 3)))
  expect_error(d_untyped$add(list(c = 4)), "Some or all")
  expect_error(d_untyped$add(list(a = 3)), "Some or all")
  expect_silent(d_untyped$add(list(d = "a")))

  expect_equal_dictionary(
    Dictionary$new(x = list(a = 1, b = 2))$add(list(c = 3, d = 4)),
    Dictionary$new(x = list(a = 1, b = 2, c = 3, d = 4))
  )

  expect_equal_dictionary(
    Dictionary$new(x = list(a = 1, b = 2))$add(keys = c("c", "d"),
                                               values = 3:4),
    Dictionary$new(x = list(a = 1, b = 2, c = 3, d = 4))
  )

  expect_error(Dictionary$new()$add(), "Either")
})

test_that("add typed", {
  d_typed <- Dictionary$new(x = list(a = 1, b = 2), types = "numeric")

  expect_silent(d_typed$add(list(c = 3)))
  expect_error(d_typed$add(list(c = 4)), "Some or all")
  expect_error(d_typed$add(list(a = 3)), "Some or all")
  expect_error(d_typed$add(list(d = "a")), "numeric")

  expect_equal_dictionary(
    Dictionary$new(x = list(a = 1, b = 2), types = "numeric")$add(list(c = 3,
                                                                   d = 4)),
    Dictionary$new(x = list(a = 1, b = 2, c = 3, d = 4), types = "numeric")
  )

  d <- Dictionary$new(x = list(a = 1, b = 2), types = "numeric")
  d[c("c", "d")] <- c(3, 4)

  expect_equal_dictionary(
    d,
    Dictionary$new(x = list(a = 1, b = 2, c = 3, d = 4), types = "numeric")
  )
})

test_that("remove", {
  d_typed <- Dictionary$new(x = list(a = 1, b = 2), types = "numeric")
  d_untyped <- Dictionary$new(x = list(a = 1, b = 2))

  expect_error(d_typed$remove("c"), "does not exist")
  expect_error(d_untyped$remove("c"), "does not exist")

  expect_equal_dictionary(d_typed$remove(letters[1:2]),
               Dictionary$new(types = "numeric"))
  expect_equal_dictionary(d_untyped$remove(letters[1:2]), Dictionary$new())

  expect_silent(d_untyped$add(list(a = 1, b = 2)))
  expect_equal_dictionary(
    d_untyped$remove("a"),
    Dictionary$new(x = list(b = 2))
  )
})

test_that("get", {
  d_untyped <- Dictionary$new(x = list(a = 1, b = "a"))
  expect_equal(d_untyped$get("a"), 1)
  expect_equal(d_untyped$get("b"), "a")
  expect_error(d_untyped$get("c"), "value for")
  expect_error(d_untyped$get(letters[1:2]), "length")

  d_typed <- Dictionary$new(x = list(a = 1, b = 2), types = "numeric")
  expect_equal(d_typed$get("a"), 1)
  expect_equal(d_typed$get("b"), 2)
  expect_equal(d_typed$get(letters[1:2]), c(1, 2))
  expect_error(d_typed$get("c"), "value for")

  d <- Dictionary$new(x = list(a = Set$new(1), b = 2))
  expect_equal(d$get("a")$values(), 1)
  expect_equal(d$get("b"), 2)

  d <- Dictionary$new(x = list(a = Set$new(1), b = Set$new(2)), types = "Set")
  expect_equal(lapply(d$get(c("a", "b")), function(x) x$values()),
               list(a = 1, b = 2))

  ## don't clone - changes s
  s <- Set$new(1)
  d <- Dictionary$new(a = s)
  d$get("a", FALSE)$add(2)
  expect_equal(s, Set$new(c(1, 2)))
  expect_equal(d$get("a")$values(), Set$new(c(1, 2))$values())

  ## clone - doesn't changes s
  s <- Set$new(1)
  d <- Dictionary$new(a = s)
  d$get("a")$add(2)
  expect_equal(s$values(), Set$new(1)$values())
  expect_equal(d$get("a")$values(), Set$new(1)$values())
  expect_equal(d$get("a")$add(2)$values(), Set$new(c(1, 2))$values())

  d <- Dictionary$new(x = list(a = Set$new(1), b = Set$new(2)), types = "Set")
  d$get(c("a", "b"), FALSE)[[1L]]$add(2)
  expect_equal(d$get("a")$values(), Set$new(c(1, 2))$values())

  d <- Dictionary$new(x = list(a = Set$new(1), b = Set$new(2)), types = "Set")
  d$get(c("a", "b"), TRUE)[[1L]]$add(2)
  expect_equal(d$get("a")$values(), Set$new(1)$values())
})

test_that("get_list", {
  d_untyped <- Dictionary$new(x = list(a = 1, b = 2))

  expect_error(d_untyped$get_list("c"), "value for")
  expect_equal(d_untyped$get_list("a"), list(a = 1))
  expect_equal(d_untyped$get_list(c("a", "b")), list(a = 1, b = 2))
  expect_equal(d_untyped[c("a", "b")], list(a = 1, b = 2))

  d <- Dictionary$new(x = list(a = Set$new(1), b = 2))
  expect_equal(d$get_list(c("a", "b"))[[1]]$values(), 1)
  expect_equal(d$get_list(c("a", "b"))[[2]], 2)
})

test_that("has", {
  d_untyped <- Dictionary$new(x = list(a = 1, b = 2))
  expect_true(d_untyped$has("a"))
  expect_false(d_untyped$has("c"))
  expect_equal(d_untyped$has(c("a", "c", "b")),
               c(a = TRUE, c = FALSE, b = TRUE))
})

test_that("has_value", {
  d_untyped <- Dictionary$new(x = list(a = 1, b = 2))
  expect_true(d_untyped$has_value(1))
  expect_false(d_untyped$has_value(3))
  expect_equal(d_untyped$has_value(1:3), c(TRUE, TRUE, FALSE))
})

test_that("rekey", {
  d_untyped <- Dictionary$new(x = list(a = 1, b = 2))
  expect_silent(d_untyped$rekey("a", "c"))
  expect_mapequal(d_untyped$items, list(c = 1, b = 2))
  expect_error(d_untyped$rekey("a", "d"), "Not all keys")
  expect_error(d_untyped$rekey("c", "b"), "already exists")
})

test_that("active", {
  d_typed <- Dictionary$new(x = list(a = 1, b = 2), types = "numeric")
  expect_setequal(d_typed$keys, c("a", "b"))
  expect_equal(d_typed$length, 2)
  expect_equal(length(d_typed), 2)

  expect_true(d_typed$typed)
  expect_false(Dictionary$new(x = list(a = 1, b = 2))$typed)

  expect_equal(d_typed$types, c("numeric"))
  expect_equal(Dictionary$new(x = list(a = 1, b = 2))$types, NULL)

  expect_setequal(d_typed$values, c(1, 2))
  expect_setequal(Dictionary$new(x = list(a = 1, b = 2))$values, list(1, 2))

  expect_mapequal(d_typed$items, list(b = 2, a = 1))
  d_typed$items$a <- 2
  expect_equal(d_typed$items, list(a = 2, b = 2))
  expect_error({ d_typed$items$a <- "c" }) # nolint
  d_typed$items$a <- NULL
  expect_equal(d_typed$items, list(b = 2))
  d_typed$items <- list(a = 3, b = 4)
  expect_mapequal(d_typed$items, list(b = 4, a = 3))

  d_typed <- Dictionary$new(x = list(a = 1, b = 2, c = 3), types = "numeric")
  d_typed$items[letters[1:2]] <- NULL
  expect_equal(d_typed$values, 3)
  d_typed$items[letters[3]] <- NULL
  expect_equal(d_typed$values, NULL)
})

test_that("print and summary", {
  d_typed <- Dictionary$new(x = list(a = 1, b = 2, c = 3), types = "numeric")
  d_untyped <- Dictionary$new(x = list(a = 1, b = 2, c = 3))

  expect_equal(as.character(d_typed), "{a: 1, b: 2, c: 3}")
  expect_equal(as.character(d_typed, 1), "{a: 1, ..., c: 3}")
  expect_equal(as.character(d_untyped, 1), "{a: 1, ..., c: 3}")

  expect_output(print(d_typed))
  expect_output(summary(d_typed))
  expect_output(summary(d_typed), "Typed dictionary of")
  expect_output(print(d_untyped))
  expect_output(summary(d_untyped))
  expect_output(summary(d_untyped), "Untyped dictionary of 3 items.")
})

test_that("concatenate", {
  a_typed <- Dictionary$new(x = list(a = 1), types = "numeric")
  b_typed <- Dictionary$new(x = list(b = 2), types = c("numeric", "integer"))
  c_typed <- Dictionary$new(x = list(c = 3), types = c("integer", "numeric"))
  d_typed <- Dictionary$new(x = list(a = 3), types = "numeric")
  e_typed <- Dictionary$new(x = list(a = 3L), types = "integer")

  a_untyped <- Dictionary$new(x = list(a = 1))
  b_untyped <- Dictionary$new(x = list(b = 2))
  c_untyped <- Dictionary$new(x = list(c = 2))
  d_untyped <- Dictionary$new(x = list(a = 2))

  expect_error(c(a_typed, b_typed), "same type")
  expect_error(c(a_typed, c_typed), "same type")
  expect_error(c(d_typed, e_typed), "same type")
  expect_error(c(a_typed, a_untyped), "typed or all")
  expect_error(c(a_typed, d_typed), "'x' must have unique")
  expect_equal_dictionary(c(b_typed, c_typed),
               Dictionary$new(x = list(b = 2, c = 3),
                              types = c("numeric", "integer")))

  expect_error(c(a_untyped, a_typed), "typed or all")
  expect_error(c(a_typed, d_typed), "'x' must have unique")
  expect_equal_dictionary(c(a_untyped, b_untyped, c_untyped),
               Dictionary$new(x = list(a = 1, b = 2, c = 2)))
})

test_that("merge", {
  a_typed <- Dictionary$new(x = list(a = 1), types = "numeric")
  c_typed <- Dictionary$new(x = list(c = 3), types = c("integer", "numeric"))
  d_typed <- Dictionary$new(x = list(a = 3), types = "numeric")

  a_untyped <- Dictionary$new(x = list(a = "b"))
  b_untyped <- Dictionary$new(x = list(b = 2))
  c_untyped <- Dictionary$new(x = list(c = 2))
  d_untyped <- Dictionary$new(x = list(a = 2))

  expect_equal(a_typed$merge(list(b_untyped, c_untyped))$items,
               list(c = 2, b = 2, a = 1))
  expect_error(a_typed$merge(a_untyped), "Some or")
  expect_error(d_typed$merge(d_untyped), "Some or")
  expect_error(a_typed$merge("a"), "Dictionary or")
})

test_that("deep clone", {
  r <- R6Class("test")
  d1 <- Dictionary$new(x = list(a = r$new(), d = 1))
  d2 <- d1$clone(deep = TRUE)
  d3 <- d1
  d2$add(list(b = 2))
  expect_equal(length(d1), length(d3))
  expect_false(length(d1) == length(d2))
})


test_that("can revalue", {
  d <- dct(a = 1)
  d$revalue("a", 2)
  expect_equal(d$get("a"), 2)

  d <- dct(a = 1, types = "numeric")
  expect_error(d$revalue("a", "b"), "inherits")
})


test_that("can add R6", {
  d <- dct(a = 1)
  d$add(keys = "b", values = Set$new(1))
  expect_setequal(d$keys, c("a", "b"))
  expect_equal(d$get("b")$values(), 1)
})

expect_equal_dictionary <- function(x, y) {
  expect_true(inherits(x, "Dictionary"))
  expect_true(inherits(y, "Dictionary"))
  expect_type(private(x)$.items, "environment")
  expect_type(private(y)$.items, "environment")
  expect_identical(x$typed, y$typed)
  if (x$typed) {
    expect_setequal(x$types, y$types)
  }
  expect_mapequal(x$items, y$items)
}

## Test Results

No NOTEs, WARNINGs, or ERRORs.

## Test environments

* Windows, R Release
* Mac OS X, R Release
* Ubuntu, R Release
* Ubuntu, R Oldrel
* Ubuntu, R Devel

## Reverse Dependencies

All reverse dependencies OK.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dct.R
\name{dct}
\alias{dct}
\title{Construct a Dictionary}
\usage{
dct(..., x = list(...), types = NULL)
}
\arguments{
\item{...}{(\code{ANY}) \cr
Named arguments with names corresponding to the items to add to the
dictionary, where the keys are the names and the values are the
elements. Names must be unique.}

\item{x}{(\code{list()}) \cr
A named list with the names corresponding to the items to add to the
dictionary, where the keys are the list names and the values are the
list elements. Names must be unique.}

\item{types}{(\code{character()}) \cr
If non-NULL then \code{types} creates a typed dictionary in which all
elements of the dictionary must inherit from these \code{types}. Any class
can be given to \code{types} as long as there is a valid \code{as.character}
method associated with the class.}
}
\description{
Sugar function wrapping \verb{[Dictionary]$new}.
}
\examples{
# untyped
dct(a = 1, b = 2, c = "a")

# typed - class is forced
dct(a = 1L, b = 2L, c = 3L, types = "integer")

# list constructor
dct(x = list(a = 1, b = 2, c = "a"))

# with R6
d <- dct(a = 1)
dct(d = d)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Dictionary.R
\name{Dictionary}
\alias{Dictionary}
\title{R6 Dictionary}
\description{
Dictionaries are essential objects in other object-oriented
languages, such as Python. The primary function of a dictionary is to store
items in a key-value pair. Where the key is the name of the item and the
value is the value. This object contains all the 'usual' methods that would
be found in other languages, including setting and getting values,
adding and removing items, and containedness checks.
}
\section{Active bindings}{
\if{html}{\out{<div class="r6-active-bindings">}}
\describe{
\item{\code{keys}}{None -> \code{character()} \cr
Get dictionary keys.}

\item{\code{values}}{None -> \code{list()} \cr
Get dictionary values.}

\item{\code{items}}{\code{list() -> self} / None -> \code{list()} \cr
If \code{x} is missing then returns the dictionary items. \cr
If \code{x} is not missing then used to set items in the dictionary.}

\item{\code{length}}{None -> \code{integer(1)} \cr
Get dictionary length as number of items.}

\item{\code{typed}}{None -> \code{logical(1)} \cr
Get if the dictionary is typed (\code{TRUE}) or not (\code{FALSE}).}

\item{\code{types}}{None -> \code{character()} \cr
Get the dictionary types (NULL if un-typed).}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-new}{\code{Dictionary$new()}}
\item \href{#method-add}{\code{Dictionary$add()}}
\item \href{#method-rekey}{\code{Dictionary$rekey()}}
\item \href{#method-revalue}{\code{Dictionary$revalue()}}
\item \href{#method-remove}{\code{Dictionary$remove()}}
\item \href{#method-get}{\code{Dictionary$get()}}
\item \href{#method-get_list}{\code{Dictionary$get_list()}}
\item \href{#method-has}{\code{Dictionary$has()}}
\item \href{#method-assert_contains}{\code{Dictionary$assert_contains()}}
\item \href{#method-has_value}{\code{Dictionary$has_value()}}
\item \href{#method-print}{\code{Dictionary$print()}}
\item \href{#method-summary}{\code{Dictionary$summary()}}
\item \href{#method-merge}{\code{Dictionary$merge()}}
\item \href{#method-clone}{\code{Dictionary$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-new"></a>}}
\if{latex}{\out{\hypertarget{method-new}{}}}
\subsection{Method \code{new()}}{
Constructs a \code{Dictionary} object.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$new(..., x = list(...), types = NULL)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{...}}{(\code{ANY}) \cr
Named arguments with names corresponding to the items to add to the
dictionary, where the keys are the names and the values are the
elements. Names must be unique.}

\item{\code{x}}{(\code{list()}) \cr
A named list with the names corresponding to the items to add to the
dictionary, where the keys are the list names and the values are the
list elements. Names must be unique.}

\item{\code{types}}{(\code{character()}) \cr
If non-NULL then \code{types} creates a typed dictionary in which all
elements of the dictionary must inherit from these \code{types}. Any class
can be given to \code{types} as long as there is a valid \code{as.character}
method associated with the class.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-add"></a>}}
\if{latex}{\out{\hypertarget{method-add}{}}}
\subsection{Method \code{add()}}{
Add new items to the dictionary.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$add(x = list(), keys = NULL, values = NULL)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{x}}{(\code{list()}) \cr
Same as initialize, items to add to the list.}

\item{\code{keys}}{(\code{character()}) \cr
If \code{x} is NULL then \code{keys} and \code{values} can be provided to add the
new items by a character vector of keys and list of values instead.}

\item{\code{values}}{(\code{list()}) \cr
If \code{x} is NULL then \code{keys} and \code{values} can be provided to add the
new items by a list of keys and values instead.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-rekey"></a>}}
\if{latex}{\out{\hypertarget{method-rekey}{}}}
\subsection{Method \code{rekey()}}{
Change the name of a given key.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$rekey(key, new_key)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{key}}{(\code{character(1)}) \cr
Key to rename.}

\item{\code{new_key}}{(\code{character(1)}) \cr
New name of key, must not already exist in dictionary.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-revalue"></a>}}
\if{latex}{\out{\hypertarget{method-revalue}{}}}
\subsection{Method \code{revalue()}}{
Change the value of a given item.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$revalue(key, new_value)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{key}}{(\code{character(1)}) \cr
Key of item to revalue.}

\item{\code{new_value}}{(\code{character(1)}) \cr
New value of item.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-remove"></a>}}
\if{latex}{\out{\hypertarget{method-remove}{}}}
\subsection{Method \code{remove()}}{
Removes the given item from the list.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$remove(key)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{key}}{(\code{character(1)}) \cr
Key of item to remove.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-get"></a>}}
\if{latex}{\out{\hypertarget{method-get}{}}}
\subsection{Method \code{get()}}{
Gets the given items from the dictionary. If only one
item is requested then returns the (unlisted) item, or if multiple items
are requested as the dictionary is typed, then the unlisted items are
returned.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$get(keys, clone = TRUE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{keys}}{(\code{character()}) \cr
Keys of items to get.}

\item{\code{clone}}{(\code{logical(1)}) \cr
If \code{TRUE} (default) then deep clones R6 objects if requested.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-get_list"></a>}}
\if{latex}{\out{\hypertarget{method-get_list}{}}}
\subsection{Method \code{get_list()}}{
Gets the given items from the dictionary as list.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$get_list(keys, clone = TRUE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{keys}}{(\code{character()}) \cr
Keys of items to get.}

\item{\code{clone}}{(\code{logical(1)}) \cr
If \code{TRUE} (default) then deep clones R6 objects if requested.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-has"></a>}}
\if{latex}{\out{\hypertarget{method-has}{}}}
\subsection{Method \code{has()}}{
Checks if the given key is in the list, returns a logical.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$has(key)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{key}}{(\code{character(1)}) \cr
Key to check.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-assert_contains"></a>}}
\if{latex}{\out{\hypertarget{method-assert_contains}{}}}
\subsection{Method \code{assert_contains()}}{
Asserts if the given keys are in the list, returns keys
invisibly if assertion passes otherwise errors.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$assert_contains(keys)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{keys}}{(\code{character()}) \cr
Keys to check.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-has_value"></a>}}
\if{latex}{\out{\hypertarget{method-has_value}{}}}
\subsection{Method \code{has_value()}}{
Checks if the given value is in the list, returns a
logical.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$has_value(value)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{value}}{(\code{ANY}) \cr
Value to check.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-print"></a>}}
\if{latex}{\out{\hypertarget{method-print}{}}}
\subsection{Method \code{print()}}{
Prints dictionary.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$print(n = 2)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{n}}{(\code{integer(1)}) \cr
Number of items to print on either side of ellipsis.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-summary"></a>}}
\if{latex}{\out{\hypertarget{method-summary}{}}}
\subsection{Method \code{summary()}}{
Summarises dictionary.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$summary(n = 2)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{n}}{(\code{integer(1)}) \cr
Number of items to print on either side of ellipsis.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-merge"></a>}}
\if{latex}{\out{\hypertarget{method-merge}{}}}
\subsection{Method \code{merge()}}{
Merges another dictionary, or list of dictionaries, into
self.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$merge(x)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{x}}{(\code{Dictionary(1) | list()}) \cr
Dictionary or list of dictionaries to merge in, must have unique keys.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-clone"></a>}}
\if{latex}{\out{\hypertarget{method-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{Dictionary$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}
